<template>
  <div v-if="loaded" class="card">
    <v-tabs v-model="tab" bg-color="w" color="yellow-darken-3" grow>
      <v-tab value="one">
        <p>คำร้องขอยืม</p>
      </v-tab>
      <v-tab value="two">
        <p>คำร้องขอคืน</p>
      </v-tab>
      <v-tab value="three">
        <p>อยู่ระหว่างยืม</p>
      </v-tab>
      <v-tab value="four">
        <p>ครบกำหนดคืน</p>
      </v-tab>
      <v-tab value="five">
        <p>สำเร็จ</p>
      </v-tab>
      <v-tab value="zero">
        <p>ยกเลิก</p>
      </v-tab>
      <v-tab @click="onSearch">
        <p>ค้นหา</p>
      </v-tab>
    </v-tabs>

    <v-card-text>
      <v-window v-model="tab">
        <v-window-item value="one">
          <v-infinite-scroll mode="manual" max-height="1000">
            <template v-for="(request) in waitingForApproval" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img
                      v-if="request.attributes.equipment.data.attributes.image.data && request.attributes.equipment.data.attributes.image.data.length > 0"
                      :src="media + request.attributes.equipment.data.attributes.image.data[0].attributes.url"
                      :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.attributes.equipment.data.attributes.name.length <= 20">
                        {{ request.attributes.equipment.data.attributes.name }}</p>
                      <p v-else>{{ request.attributes.equipment.data.attributes.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-yellow-darken-3 text-sm text-wrap align-center pr-3 text-end">รออนุมัติ</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">
                      {{ request.attributes.equipment.data.attributes.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.attributes.equipment.data.attributes.detail" class="text-sm">
                          {{ request.attributes.equipment.data.attributes.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.attributes.equipment.data.attributes.day_limit }} <span>วัน</span>
                        </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้ยืม</p>
                        <p class="text-sm">{{ request.attributes.user.data.attributes.prefix +
                          request.attributes.user.data.attributes.firstname + " " +
                          request.attributes.user.data.attributes.lastname }}
                        </p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">ส่งคำขอเมื่อ {{ formatDateTime(request.attributes.createdAt) }}</span>
                      </div>
                      <div v-if="request.attributes.user.data.attributes.histories.data.length != 0"
                        :id="ratingValue = calculateAverage(request.attributes.user.data.attributes.histories.data)"
                        class="text-center mt-2">
                        <p class="text-sm"><strong>{{ ratingValue }}</strong> <span>({{
                          request.attributes.user.data.attributes.histories.data.length }})</span></p>
                        <v-rating v-model="ratingValue" half-increments readonly></v-rating>
                      </div>
                      <div v-else :id="ratingValue = 0" class="text-center mt-2">
                        <p class="text-sm">ยังไม่เคยใช้บริการ</p>
                        <v-rating v-model="ratingValue" half-increments readonly></v-rating>
                      </div>
                      <v-btn
                        @click="onApprove(request.id, request.attributes.equipment.data.attributes.day_limit, request.attributes.equipment.data.id, request.attributes.equipment.data.attributes.quantity)"
                        :loading="approveLoading" block class="text-none mt-2 btn" color="green" size="small"
                        variant="flat">
                        อนุมัติ
                      </v-btn>
                      <v-btn @click="onCancle(request.id)" :loading="cancleLoading" block class="text-none mt-2 btn"
                        color="grey-lighten-3" size="small" variant="flat">
                        ยกเลิก
                      </v-btn>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>

        <v-window-item value="two">
          <v-infinite-scroll mode="manual" max-height="1000">

            <template v-for="(request) in waitingForReturnApproval" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img
                      v-if="request.attributes.equipment.data.attributes.image.data && request.attributes.equipment.data.attributes.image.data.length > 0"
                      :src="media + request.attributes.equipment.data.attributes.image.data[0].attributes.url"
                      :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.attributes.equipment.data.attributes.name.length <= 20">
                        {{ request.attributes.equipment.data.attributes.name }}</p>
                      <p v-else>{{ request.attributes.equipment.data.attributes.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-teal-darken-2 text-sm text-wrap align-center pr-3 text-end">รออนุมัติ</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">
                      {{ request.attributes.equipment.data.attributes.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.attributes.equipment.data.attributes.detail" class="text-sm">
                          {{ request.attributes.equipment.data.attributes.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.attributes.equipment.data.attributes.day_limit }} <span>วัน</span>
                        </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">ส่งคำขอคืนเมื่อ {{ formatDateTime(request.attributes.updatedAt)
                          }}</span>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้ยืม</p>
                        <p class="text-sm">{{ request.attributes.user.data.attributes.prefix +
                          request.attributes.user.data.attributes.firstname + " " +
                          request.attributes.user.data.attributes.lastname }}
                        </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้อนุมัติยืม</p>
                        <p class="text-sm">{{ request.attributes.giver }}</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">อนุมัติเมื่อ {{ formatDateTime(request.attributes.borrowed) }}</span>
                      </div>
                      <v-btn
                        @click="onReturnApprove(request.id, request.attributes.equipment.data.id, request.attributes.equipment.data.attributes.quantity)"
                        :loading="approveLoading" block class="text-none mt-2 btn" color="teal-darken-2" size="small"
                        variant="flat">
                        อนุมัติ
                      </v-btn>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>

        <v-window-item value="three">
          <v-infinite-scroll mode="manual" max-height="1000">

            <template v-for="(request) in borrowingList" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img
                      v-if="request.attributes.equipment.data.attributes.image.data && request.attributes.equipment.data.attributes.image.data.length > 0"
                      :src="media + request.attributes.equipment.data.attributes.image.data[0].attributes.url"
                      :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.attributes.equipment.data.attributes.name.length <= 20">
                        {{ request.attributes.equipment.data.attributes.name }}</p>
                      <p v-else>{{ request.attributes.equipment.data.attributes.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-green-darken-3 text-sm text-wrap align-center pr-3 text-end">อยู่ระหว่างการยืม</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">
                      {{ request.attributes.equipment.data.attributes.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.attributes.equipment.data.attributes.detail" class="text-sm">
                          {{ request.attributes.equipment.data.attributes.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.attributes.equipment.data.attributes.day_limit }} <span>วัน</span>
                        </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">กำหนดการคืน</p>
                        <p class="text-sm">{{ formatDateThai(request.attributes.return_schedule) }}</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้ยืม</p>
                        <p class="text-sm">{{ request.attributes.user.data.attributes.prefix +
                          request.attributes.user.data.attributes.firstname + " " +
                          request.attributes.user.data.attributes.lastname }}
                        </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้อนุมัติยืม</p>
                        <p class="text-sm">{{ request.attributes.giver }}</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">อนุมัติเมื่อ {{ formatDateTime(request.attributes.updatedAt) }}</span>
                      </div>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>

        <v-window-item value="four">
          <v-infinite-scroll mode="manual" max-height="1000">

            <template v-for="(request) in returnList" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img
                      v-if="request.attributes.equipment.data.attributes.image.data && request.attributes.equipment.data.attributes.image.data.length > 0"
                      :src="media + request.attributes.equipment.data.attributes.image.data[0].attributes.url"
                      :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.attributes.equipment.data.attributes.name.length <= 20">
                        {{ request.attributes.equipment.data.attributes.name }}</p>
                      <p v-else>{{ request.attributes.equipment.data.attributes.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-orange-darken-3 text-sm text-wrap align-center pr-3 text-end">ครบกำหนดคืน</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">
                      {{ request.attributes.equipment.data.attributes.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.attributes.equipment.data.attributes.detail" class="text-sm">
                          {{ request.attributes.equipment.data.attributes.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.attributes.equipment.data.attributes.day_limit }} <span>วัน</span>
                        </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">กำหนดการคืน</p>
                        <p class="text-sm">{{ formatDateThai(request.attributes.return_schedule) }}</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้ยืม</p>
                        <p class="text-sm">{{ request.attributes.user.data.attributes.prefix +
                          request.attributes.user.data.attributes.firstname + " " +
                          request.attributes.user.data.attributes.lastname }}
                        </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้อนุมัติยืม</p>
                        <p class="text-sm">{{ request.attributes.giver }}</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">อนุมัติเมื่อ {{ formatDateTime(request.attributes.updatedAt) }}</span>
                      </div>
                      <v-btn @click="onResendEmail(request.id)" :loading="sendemailLoading" block
                        class="text-none mt-2 btn" color="orange-darken-3" size="small" variant="flat">
                        ส่งอีเมลแจ้งเตือน
                      </v-btn>
                      <v-btn @click="onGetback(request.id)" :loading="getbackLoading" block class="text-none mt-2"
                        color="orange-darken-3" size="small" variant="outlined">
                        คืนอุปกรณ์แล้ว
                      </v-btn>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>

        <v-window-item value="five">
          <v-infinite-scroll mode="manual" max-height="1000">

            <template v-for="(request) in successList" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img
                      v-if="request.attributes.equipment.data.attributes.image.data && request.attributes.equipment.data.attributes.image.data.length > 0"
                      :src="media + request.attributes.equipment.data.attributes.image.data[0].attributes.url"
                      :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.attributes.equipment.data.attributes.name.length <= 20">
                        {{ request.attributes.equipment.data.attributes.name }}</p>
                      <p v-else>{{ request.attributes.equipment.data.attributes.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-green text-sm text-wrap align-center pr-3 text-end">สำเร็จ</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">
                      {{ request.attributes.equipment.data.attributes.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.attributes.equipment.data.attributes.detail" class="text-sm">
                          {{ request.attributes.equipment.data.attributes.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.attributes.equipment.data.attributes.day_limit }} <span>วัน</span>
                        </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้ยืม</p>
                        <p class="text-sm">{{ request.attributes.user.data.attributes.prefix +
                          request.attributes.user.data.attributes.firstname + " " +
                          request.attributes.user.data.attributes.lastname }}
                        </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้อนุมัติยืม</p>
                        <p class="text-sm">{{ request.attributes.giver }}</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">อนุมัติเมื่อ {{ formatDateTime(request.attributes.borrowed) }}</span>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้อนุมัติคืน</p>
                        <p class="text-sm">{{ request.attributes.giver }}</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">อนุมัติเมื่อ {{ formatDateTime(request.attributes.returned) }}</span>
                      </div>
                    </div>
                    <div class="text-center mt-2">
                      <v-rating v-if="request.attributes.history.data"
                        v-model="request.attributes.history.data.attributes.score" :half-increments="true"
                        hover></v-rating>
                      <v-rating v-else v-model="ratingScore" :half-increments="true" hover></v-rating>
                      <p v-if="!request.attributes.history.data" class="text-sm">ยังไม่ให้คะแนน</p>
                      <v-btn
                        @click="onSendRating(request.attributes.history.data ? request.attributes.history.data.attributes.score : ratingScore, request.id, request.attributes.user.data.id)"
                        :loading="sendRatingLoading" block class="text-none mt-2 btn" color="green" size="small"
                        variant="flat">
                        ส่ง
                      </v-btn>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>

        <v-window-item value="zero">
          <v-infinite-scroll mode="manual" max-height="1000">

            <template v-for="(request) in cancleList" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img
                      v-if="request.attributes.equipment.data.attributes.image.data && request.attributes.equipment.data.attributes.image.data.length > 0"
                      :src="media + request.attributes.equipment.data.attributes.image.data[0].attributes.url"
                      :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.attributes.equipment.data.attributes.name.length <= 20">
                        {{ request.attributes.equipment.data.attributes.name }}</p>
                      <p v-else>{{ request.attributes.equipment.data.attributes.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-red text-sm text-wrap align-center pr-3 text-end">ยกเลิก</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">
                      {{ request.attributes.equipment.data.attributes.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.attributes.equipment.data.attributes.detail" class="text-sm">
                          {{ request.attributes.equipment.data.attributes.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.attributes.equipment.data.attributes.day_limit }} <span>วัน</span>
                        </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้ยืม</p>
                        <p class="text-sm">{{ request.attributes.user.data.attributes.prefix +
                          request.attributes.user.data.attributes.firstname + " " +
                          request.attributes.user.data.attributes.lastname }}
                        </p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">ยกเลิกเมื่อ {{ formatDateTime(request.attributes.updatedAt) }}</span>
                      </div>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>
      </v-window>

    </v-card-text>
  </div>
  <div v-if="!loaded" class="card d-flex flex-column mb-2">
    <v-skeleton-loader type="heading"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | จัดการรายการ",
  meta: [{ name: "description", content: "จัดการรายการ" }],
});
definePageMeta({
  middleware: "admin",
});

import { ref } from 'vue'
import axios from "axios"

const token = useStrapiToken();
const url = useStrapiUrl();
const media = useStrapiMedia();

const tab = ref()
const loaded = ref(false)

const providerData = ref()

const waitingForApproval = ref([])
const borrowingList = ref([])
const returnList = ref([])
const waitingForReturnApproval = ref([])
const successList = ref([])
const cancleList = ref([])

const cancleLoading = ref(false)
const approveLoading = ref(false)
const sendemailLoading = ref(false)
const sendRatingLoading = ref(false)
const getbackLoading = ref(false)

const ratingScore = ref(0)

function calculateAverage(data) {
  // ตรวจสอบว่าข้อมูลไม่ใช่ null หรือ undefined
  if (!data || !Array.isArray(data) || data.length === 0) {
    return null;
  }

  let totalScore = 0;
  for (let i = 0; i < data.length; i++) {
    // ตรวจสอบว่าข้อมูลประวัติมี attributes และ attributes มีค่า score
    if (data[i].attributes && typeof data[i].attributes.score === 'number') {
      totalScore += data[i].attributes.score;
    }
  }

  const averageScore = totalScore / data.length;
  return averageScore;
}

async function onGetback(requestID) {
  getbackLoading.value = true;
  await new Promise(resolve => setTimeout(resolve, 500));

  try {
    console.log("Return ID : ", requestID)
    await axios.put(`${url}/requests/${requestID}`, {
      data: {
        status: 4
      }
    }, {
      headers: {
        Authorization: `Bearer ${token.value}`,
      }
    })
    await getBorrowingReturnList();
    getbackLoading.value = false;
    
  } catch (error) {
    console.log(error.error)
  }
}

async function onSendRating(rating, requestId, userId) {
  sendRatingLoading.value = true;
  await new Promise(resolve => setTimeout(resolve, 500));

  const response = await axios.get(`${url}/requests/${requestId}`, {
    params: {
      fields: {
        0: 'id'
      },
      populate: {
        history: {
          fields: {
            1: 'score'
          }
        }
      }
    },
    headers: {
      'Authorization': `Bearer ${token.value}`,
    }
  })

  if (response.data.data.attributes.history.data == null) {
    try {
      await axios.post(`${url}/histories`, {
        data: {
          score: rating,
          user: { connect: [userId] },
          request: { connect: [requestId] },
        }
      }, {
        headers: {
          Authorization: `Bearer ${token.value}`,
        }
      })
      getBorrowingReturnList();

    } catch (error) {
      console.log(error)
    }

  } else {
    try {
      await axios.put(`${url}/histories/${response.data.data.attributes.history.data.id}`, {
        data: {
          score: rating,
        }
      }, {
        headers: {
          Authorization: `Bearer ${token.value}`,
        }
      })
      getBorrowingReturnList();

    } catch (error) {
      console.log(error)
    }
    console.log("History ID : ", response.data.data.attributes.history.data.id)
  }

  sendRatingLoading.value = false;
}

async function onApprove(requestId, dayLimit, equipmentId, quantity) {
  approveLoading.value = true;

  const today = new Date();
  const returnDate = new Date(today.setDate(today.getDate() + dayLimit));
  const returnSchedule = returnDate.toISOString().split('T')[0];
  const current = today.toISOString();

  if (quantity >= 1) {
    try {
      await axios.put(`${url}/equipments/${equipmentId}`, {
        data: {
          quantity: quantity - 1,
        }
      }, {
        headers: {
          Authorization: `Bearer ${token.value}`,
        }
      })

      await axios.put(`${url}/requests/${requestId}`, {
        data: {
          status: 2,
          return_schedule: returnSchedule,
          giver: providerData.value.prefix + providerData.value.firstname + " " + providerData.value.lastname,
          borrowed: current,
        }
      }, {
        headers: {
          Authorization: `Bearer ${token.value}`,
        }
      })

      approveLoading.value = false;
      await getBorrowingReturnList();
    } catch (error) {
      console.log(error)
    }
  } else {
    console.log("อุปกรณ์หมดแล้ว")
  }
}

async function onReturnApprove(requestId, equipmentId, quantity) {
  approveLoading.value = true
  const today = new Date();
  const current = today.toISOString();

  try {
    await axios.put(`${url}/equipments/${equipmentId}`, {
      data: {
        quantity: quantity + 1,
      }
    }, {
      headers: {
        Authorization: `Bearer ${token.value}`,
      }
    })

    await axios.put(`${url}/requests/${requestId}`, {
      data: {
        status: 5,
        receiver: providerData.value.prefix + providerData.value.firstname + " " + providerData.value.lastname,
        returned: current,
      }
    }, {
      headers: {
        Authorization: `Bearer ${token.value}`,
      }
    })

    approveLoading.value = false
    console.log("Return Approved")
    await getBorrowingReturnList();
  } catch (error) {
    console.log(error)
  }
}

async function onCancle(requestId) {
  cancleLoading.value = true;
  await new Promise(resolve => setTimeout(resolve, 500));
  cancleLoading.value = false;
  console.log("Cancle ID : ", requestId)
  await axios.put(`${url}/requests/${requestId}`, {
    data: {
      status: 0
    }
  }, {
    headers: {
      Authorization: `Bearer ${token.value}`,
    }
  })

  await getBorrowingReturnList();
}

async function onResendEmail(requestId) {
  sendemailLoading.value = true;
  await new Promise(resolve => setTimeout(resolve, 500));
  sendemailLoading.value = false;
  console.log("Resend Email ID : ", requestId)

  await axios.put(`${url}/requests/${requestId}`, {
    data: {
      status: 3
    }
  }, {
    headers: {
      Authorization: `Bearer ${token.value}`,
    }
  })

  await getBorrowingReturnList();
}

async function onSearch() {
  navigateTo('/search-requests')
}

async function getBorrowingReturnList() {
  try {
    await axios.get(`${url}/requests`, {
      params: {
        filters: {
          department: providerData.value.department.id,
        },
        populate: {
          equipment: {
            fields: {
              1: 'name',
              2: 'provider_name',
              3: 'day_limit',
              4: 'quantity',
            },
            populate: {
              image: {
                fields: {
                  5: 'url',
                }
              }
            }
          },
          history: {
            fields: {
              6: 'score',
            }
          },
          user: {
            fields: {
              7: 'prefix',
              8: 'firstname',
              9: 'lastname',
            },
            populate: {
              histories: {
                fields: {
                  10: 'score',
                }
              }
            }
          }
        }
      },
      headers: {
        'Authorization': `Bearer ${token.value}`,
      }
    }).then((response) => {
      const requests = response.data.data;
      waitingForApproval.value = requests.filter(request => request.attributes.status === 1).reverse();
      borrowingList.value = requests.filter(request => request.attributes.status === 2).reverse();
      returnList.value = requests.filter(request => request.attributes.status === 3).reverse();
      waitingForReturnApproval.value = requests.filter(request => request.attributes.status === 4).reverse();
      successList.value = requests.filter(request => request.attributes.status === 5).reverse();
      cancleList.value = requests.filter(request => request.attributes.status === 0).reverse();
    })

  } catch (error) {
    console.log("error : ", error)
  }
}

async function getProviderDate() {
  const response = await axios.get(`${url}/users/me`, {
    params: {
      populate: {
        department: {
          fields: {
            0: 'id',
          }
        }
      }
    },
    headers: {
      'Authorization': `Bearer ${token.value}`,
    }
  })

  providerData.value = response.data
}

// ฟังก์ชัน formatDateThai เพื่อแปลงวันที่เป็นภาษาไทย
const formatDateThai = (dateStr) => {
  if (dateStr === null) {
    return 'Invalid date';
  }

  const monthsTh = ['มกราคม', 'กุมภาพันธ์', 'มีนาคม', 'เมษายน', 'พฤษภาคม', 'มิถุนายน', 'กรกฎาคม', 'สิงหาคม', 'กันยายน', 'ตุลาคม', 'พฤศจิกายน', 'ธันวาคม'];
  const parts = dateStr.split("-");
  const day = parseInt(parts[2], 10); // แปลงเป็นตัวเลขเพื่อตัด 0 ด้านหน้า
  const monthIndex = parseInt(parts[1], 10) - 1;
  const year = parseInt(parts[0], 10) + 543; // เพิ่ม 543 เพื่อแปลงเป็น พ.ศ.

  // กำหนดรูปแบบของวันที่และเดือนให้ไม่มีเลข 0 ด้านหน้า
  const formattedDay = day.toString();
  const formattedMonth = monthsTh[monthIndex];

  return `${formattedDay} ${formattedMonth} ${year}`;
}

const formatDateTime = (timestamp) => {
  const utcDateTime = new Date(timestamp);
  const options = {
    year: 'numeric', month: '2-digit', day: '2-digit',
    hour: '2-digit', minute: '2-digit', second: '2-digit',
    timeZone: 'Asia/Bangkok'
  };
  return utcDateTime.toLocaleString('th-TH', options);
};

onMounted(async () => {
  await getProviderDate();
  await getBorrowingReturnList();
  loaded.value = true
})
</script>

<style scoped>
@import url(../assets/css/styles/borrowing-return.css);
</style>